-- speckichars menu, characters-only, not in full version

COM_AddCommand("specki_customize", function(p)
	if not (p.mo and p.mo.valid) then 
		CONS_Printf(p, "Sorry, but this command can only be used in-level!!\n")
		return 
	end
	
	if not p.mo.health or (p.mo.skin ~= "specki" and p.mo.skin ~= "maril") then
		CONS_Printf(p, "Hey, you're either trying to open the customize menu as someone other than specki or maril, or you're dead, hold on until you're properly here!\n")
		return
	end
	
	if not p.speckichars_menu then
		p.speckichars_menu = true
		p.powers[pw_nocontrol] = 1
		p.premenumus = S_MusicName()
		S_ChangeMusic("CSTMZE", true, p, 0, 0, 100, 100)
	else
		p.speckichars_menu = false
		p.powers[pw_nocontrol] = 0
		S_ChangeMusic(p.premenumus, true, p, 0, 0, 100, 100)
	end
end)

addHook("MapChange", do
	for p in players.iterate do
		p.alivetime = 0
		p.speckichars_menu = false
		p.openedspeckichars_menu = false
	end
end)

addHook("PlayerThink", function(p)
	if not (p.mo and p.mo.valid) then return end
	if not p.mo.health or not speckichars.isSpeckiChar(p.mo.skin) then return end
	
	if p.speckichars_menu == nil then
		p.speckichars_menu = false
		p.speckichars_menu_cursorpos = 1
		p.speckichars_menu_submenu = 1
	end
	
	if p.openedspeckichars_menu == nil then
		p.openedspeckichars_menu = false
	end
	
	if not p.alivetime then
		p.alivetime = 1
	else
		p.alivetime = $+1
	end
	
	if (p.cmd.buttons & BT_CUSTOM2) then
		p.openmenutimer = $+1
	else
		p.openmenutimer = 0
	end
	
	if p.openmenutimer >= 105 then
		COM_BufInsertText(p, "specki_customize")
		p.openmenutimer = 0
	end
	
	if p.speckichars_menu then
		p.openedspeckichars_menu = true
		
		if not (p.cmd.forwardmove > 0) then
			p.speckichars_menu_up = 0
		else
			p.speckichars_menu_up = $+1
			p.speckichars_menu_lastpressed = 0
		end
		
		if not (p.cmd.forwardmove < 0) then
			p.speckichars_menu_down = 0
		else
			p.speckichars_menu_down = $+1
			p.speckichars_menu_lastpressed = 1
		end
		
		local submen = p.speckichars_menu_submenu
		local curpos = p.speckichars_menu_cursorpos
		local option = speckichars.menu[submen][curpos]
		local lastpressed = p.speckichars_menu_lastpressed
		local uptap = (p.speckichars_menu_up == 1)
		local downtap = (p.speckichars_menu_down == 1)
		
		if uptap then
			curpos = $-1
		elseif downtap then
			curpos = $+1
		end
		
		if option.type == "string" then
			if lastpressed == 0 then
				curpos = $-1
			else
				curpos = $+1
			end
		end
		
		if curpos > #speckichars.menu[submen] then
			curpos = 1
		elseif curpos < 1 then
			curpos = #speckichars.menu[submen]
		end
		
		local cvar
		if type(option.var) == "string" then
			cvar = CV_FindVar(option.var)
		end
		
		if p.specki_jumptap then
			if option.type == "submenu" then
				submen = option.var
				curpos = 1
			elseif option.type == "cvar" then
				if cvar.value == 0 then
					CV_Set(cvar, 1)
				elseif cvar.value == 1 then
					CV_Set(cvar, 0)
				end
			elseif option.type == "pvar" then
				if option.var() == false then
					option.var(true)
				elseif option.var() == true then
					option.var(false)
				end
			end
		elseif p.specki_spintap then
			if option.type == "cvar" then
				if cvar.value == 1 then
					CV_Set(cvar, 0)
				end
			elseif option.type == "pvar" then
				if option.var() == true then
					option.var(false)
				end
			end
		end
		
		p.speckichars_menu_submenu = submen
		p.speckichars_menu_cursorpos = curpos
	end
end)

-- The menu is draw in hud.lua.
speckichars.menu = {
	{ -- main menu, index 1
		{
			name = "Character Options",
			type = "submenu",
			x = 320-90,
			y = 8,
			flags = V_ALLOWLOWERCASE|V_SNAPTORIGHT,
			var = 2,
			items = nil
		},
		
		{
			name = "Music Options",
			type = "submenu",
			x = 320-90,
			y = 32,
			flags = V_ALLOWLOWERCASE|V_SNAPTORIGHT,
			var = 3,
			items = nil
		}
	},
	
	{ -- character options menu, index 2
	
		{
			name = "Specki Options",
			type = "string",
			x = 320-90,
			y = 8,
			flags = V_ALLOWLOWERCASE|V_SNAPTORIGHT,
			var = "center",
			items = nil
		},
		
		{
			name = "Rainbow Effect",
			type = "pvar",
			x = 144+8,
			y = 20,
			flags = V_ALLOWLOWERCASE|V_SNAPTORIGHT,
			var = function(set)
				if set ~= nil then
					speckichars.vars.specki_rainboweffect = set
				else
					return speckichars.vars.specki_rainboweffect
				end
			end,
			
			items = {
				"Off",
				"On"
			}
		},
		
		{
			name = "Maril Options",
			type = "string",
			x = 320-90,
			y = 108,
			flags = V_ALLOWLOWERCASE|V_SNAPTORIGHT,
			var = "center",
			items = nil
		},
		
		{
			name = "Swimming",
			type = "pvar",
			x = 144+8,
			y = 120,
			flags = V_ALLOWLOWERCASE|V_SNAPTORIGHT,
			var = function(set)
				if set ~= nil then
					speckichars.vars.maril_canswim = set
				else
					return speckichars.vars.maril_canswim
				end
			end,
			
			items = {
				"Off",
				"On"
			}
		},
		
		{
			name = "Back",
			type = "submenu",
			x = 320-90,
			y = 184,
			flags = V_SNAPTORIGHT,
			var = 1,
			items = nil
		}
	
	},
	
	{ -- music options menu, index 3
		{
			name = "Custom Music",
			type = "cvar",
			x = 152,
			y = 8,
			flags = V_ALLOWLOWERCASE|V_SNAPTORIGHT,
			var = "speckichars_custommusic",
			items = {
				"Off",
				"On"
			}
		},
		
		{
			name = "PTSR Custom Music",
			type = "cvar",
			x = 152,
			y = 20,
			flags = V_ALLOWLOWERCASE|V_SNAPTORIGHT,
			var = "speckichars_ptsrcustommusic",
			items = {
				"Off",
				"On"
			}
		},
		
		{
			name = "Back",
			type = "submenu",
			x = 320-90,
			y = 184,
			flags = V_SNAPTORIGHT,
			var = 1,
			items = nil
		}
	}
}

speckichars.menufuncs = {
	drawSubmenu = function(v, x, y, name, flags, selected)
		if selected then
			v.drawString(x, y, name, flags|V_YELLOWMAP, "center")
			v.drawFill(x-v.stringWidth(name, flags)/2, y+10, v.stringWidth(name, flags), 1, 0|flags)
		else
			v.drawString(x, y, name, flags, "center")
			v.drawFill(x-v.stringWidth(name, flags)/2, y+10, v.stringWidth(name, flags), 1, 0|flags)
		end
	end,
	
	drawVar = function(v, x, y, name, value, flags, selected)
		if type(value) == "function" then
			value = value()
		end
	
		if selected then
			v.drawString(x, y, name, flags|V_YELLOWMAP)
			
			v.drawString(x+v.stringWidth(name, flags)+8, y, "<", flags|V_YELLOWMAP, "thin")
			v.drawString(x+v.stringWidth(name, flags)+14, y, value, flags, "thin")
			v.drawString(x+v.stringWidth(name, flags)+16+v.stringWidth(value, flags, "thin"), y, ">", flags|V_YELLOWMAP, "thin")
		else
			v.drawString(x, y, name, flags)
			
			v.drawString(x+v.stringWidth(name, flags)+14, y, value, flags, "thin")
		end
	end
}