local cusmus = CV_RegisterVar({
	name = "speckichars_custommusic",
	defaultvalue = "On",
	flags = CV_CALL|CV_NOINIT,
	PossibleValue = CV_OnOff,
	func = speckichars.savecvars
})

local ptsrmus = CV_RegisterVar({
	name = "speckichars_ptsrcustommusic",
	defaultvalue = "On",
	flags = CV_CALL|CV_NOINIT,
	PossibleValue = CV_OnOff,
	func = speckichars.savecvars
})

local music = {
	["specki"] = {
	},
	
	["maril"] = {
	},
	
	["both"] = {
		["OLAF"] = "SPOLAF"
	}
}

local ptsrmusic = {
	["specki"] = {
		["PIZTIM"] = "SPIZTM",
		["DEAOLI"] = "SPLAP2",
		["PIJORE"] = "SPLAP3",
		["GLUWAY"] = "SPLAP4",
		["PASTVI"] = "SPLAP5",
		["OVRTME"] = "SOVRTM",
		["OTHARD"] = "SOVRHD"
	},
	
	["maril"] = {
		["PIZTIM"] = "MPIZTM",
		["DEAOLI"] = "MRLAP2",
		["PIJORE"] = "MRLAP3",
		["GLUWAY"] = "MRLAP4",
		["PASTVI"] = "MRLAP5",
		["OVRTME"] = "MOVRTM",
		//["OTHARD"] = "MOVRHD"
		
	}
}

addHook("MusicChange", function(old, new, mflags, loop, pre, inf)
	if not (displayplayer and displayplayer.valid) then return end
	if displayplayer.skin ~= #skins["specki"] and displayplayer.skin ~= #skins["maril"] then return end
	
	if ptsrmus.value == 1 then
		if displayplayer.skin == #skins["specki"] then
			if ptsrmusic["specki"][new] ~= nil then
				mapmusname = ptsrmusic["specki"][new]
				return ptsrmusic["specki"][new]
			else
				return new
			end
		else
			if ptsrmusic["maril"][new] ~= nil then
				mapmusname = ptsrmusic["maril"][new]
				return ptsrmusic["maril"][new]
			else
				return new
			end
		end
	end
	
	if cusmus.value == 1 then
		if displayplayer.skin == #skins["specki"] then
			if music["specki"][new] ~= nil then
				mapmusname = music["specki"][new]
				return music["specki"][new]
			elseif music["both"][new] ~= nil then
				return music["both"][new]
			else
				return new
			end
		else
			if music["maril"][new] ~= nil then
				mapmusname = music["maril"][new]
				return music["maril"][new]
			elseif music["both"][new] ~= nil then
				return music["both"][new]
			else
				return new
			end
		end
	end
end)

addHook("PlayerThink", function(p)
	//if not (p.mo and p.mo.valid) then return end
	if not speckichars.isSpeckiChar(p.skin) then return end
	
	local new = string.upper(S_MusicName())
	local mus = S_MusicName()
	
	if ptsrmus.value == 1 then
		local nomusic = CV_FindVar("PTSR_nomusic")
		
		if nomusic ~= nil then
			if mus == "OVRTME"
			or mus == "OTHARD"
			or mus == "SOVRTM"
			or mus == "SOVRHD"
			or mus == "MOVRTM"
			or mus == "MOVRHD" then
				if nomusic.value == 0 then
					CV_Set(nomusic, 1)
				end
			else
				if nomusic.value == 1 then
					CV_Set(nomusic, 0)
				end
			end
		end
		
		if p.skin == #skins["specki"] then
			if ptsrmusic["specki"][new] ~= nil then
				mapmusname = ptsrmusic["specki"][new]
				S_ChangeMusic(ptsrmusic["specki"][new], true, p)
			end
		else
			if ptsrmusic["maril"][new] ~= nil then
				mapmusname = ptsrmusic["maril"][new]
				S_ChangeMusic(ptsrmusic["maril"][new], true, p)
			end
		end
	end
	
	if cusmus.value == 1 then
		if p.skin == #skins["specki"] then
			if music["specki"][new] ~= nil then
				mapmusname = music["specki"][new]
				S_ChangeMusic(music["specki"][new], true, p)
			end
		else
			if music["maril"][new] ~= nil then
				mapmusname = music["maril"][new]
				S_ChangeMusic(music["maril"][new], true, p)
			end
		end
		
		if music["both"][new] ~= nil then
			mapmusname = music["both"][new]
			S_ChangeMusic(music["both"][new], true, p)
		end
	end
end)