rawset(_G, "speckichars", {})

speckichars.save = function()
	local savef = io.openlocal("client/speckichars/save.txt", "w+")
	local string = ""
	local vars = speckichars.vars
	
	string = $ .. "This is a save file for speckichars, DO NOT TOUCH UNLESS YOU KNOW WHAT YOU'RE DOING!\n"
	string = $ .. tostring(speckichars.VERSIONNUM) .. "\n"
	
	for k, v in pairs(vars) do
		string = $ .. k .. " = " .. tostring(v) .. "\n"
	end
	
	savef:write(string)
	savef:close()
end

speckichars.savecvars = function()
	local savef = io.openlocal("client/speckichars/cvars.txt", "w+")
	local string = ""
	
	string = $ .. "This saves all the speckichars cvars, DO NOT TOUCH UNLESS YOU KNOW WHAT YOU'RE DOING!\n"
	string = $ .. tostring(speckichars.VERSIONNUM) .. "\n"
	
	local mus = CV_FindVar("speckichars_custommusic").value
	local ptsrmus = CV_FindVar("speckichars_ptsrcustommusic").value
	
	string = $ .. tostring(mus) .. "\n"
	string = $ .. tostring(ptsrmus) .. "\n"
	
	savef:write(string)
	savef:close()
end

speckichars.VERSION = "v1.2"
speckichars.VERSIONNUM = 3 -- increment by 1 every time i release a new version, patches however shouldn't cause issues

speckichars.skins = {
	"specki",
	"maril"
}

speckichars.isSpeckiChar = function(skin)
	for _, v in ipairs(speckichars.skins) do
		if type(skin) == "string" then
			if skin == v then return true else continue end
		elseif type(skin) == "number" then
			if skins[skin].name == v then return true else continue end
		end		
	end
	
	return false
end

speckichars.vars = {
	maril_canswim = true,
	specki_rainboweffect = true,
	black_emerald = false
}

speckichars.specki_trickframes = {
	{SPR2_TWIN, 0},
	{SPR2_TWIN, 1},
	{SPR2_TWIN, 2},
	{SPR2_TWIN, 3}
}

freeslot(
	"S_SPECKI_DANCE", 
	"S_SPECKI_PRIDE",
	"S_SPECKI_SLEEP",
	"S_SPECKI_TRICK"
)

states[S_SPECKI_SLEEP] = {
	sprite = SPR_PLAY,
	frame = SPR2_BNCE|FF_ANIMATE,
	tics = -1,
	var1 = 1,
	var2 = 35,
	nextstate = nil
}

states[S_SPECKI_DANCE] = {
	sprite = SPR_PLAY,
	frame = SPR2_MLEE|FF_ANIMATE,
	tics = -1,
	var1 = 5,
	var2 = (35*FRACUNIT)/1000*150/FRACUNIT,
	nextstate = nil
}

states[S_SPECKI_PRIDE] = {
	sprite = SPR_PLAY,
	frame = SPR2_MLEL|FF_ANIMATE,
	tics = -1,
	var1 = 1,
	var2 = (35*FRACUNIT)/1000*150/FRACUNIT,
	nextstate = nil
}

states[S_SPECKI_TRICK] = {
	sprite = SPR_PLAY,
	frame = SPR2_TWIN|A,
	tics = 8,
	nextstate = S_PLAY_FALL
}

local files = {
	"stuffused/custom_hud.lua",
	"speckimovesets.lua",
	"maril.lua",
	"menu.lua",
	"hud.lua",
	"music.lua",
	"pizza.lua",
	"achievements.lua",
	"achievements/checks.lua",
	"achievements/unhinged_warrior.lua"
}

for i=1, #files do
	dofile(files[i])
end